/*----------------------------------------*\
|                                          |
| >>AGBMIDI 1.0                            |
|                                          |
\*----------------------------------------*/

/*

THESE ARE EXTENDED FEATURES OF AGBMIDI.
ONLY USE IF YOU KNOW WHAT YOU ARE DOING!!!

*/

typedef struct {
	short	type;
	short	stat;
	int		freq;
	int		loop;
	int		size;
	char	data[];
} Am10_Sample;

typedef struct {
	char	st;		//Status
					// -Clear for pause
					// -Logical or 02h for note-off
					// -Logical or 01h for note-on
	char	mk;		//MIDI Key
	char	r1;		//Reserved
	char	r2;		//Reserved
	int		po;		//Length of sample - position	(Q12)
	int		fr;		//Playback frequency
	void	*ep;	//Sample pointer + Length of sample
	
	short	ad;		//Attack envelope				(Q8)
	short	at;		//Current attack value			(Q8)
	short	dd;		//Decay envelope				(Q8)
	short	de;		//Current decay value			(Q8)
	short	rd;		//Release envelope				(Q8)
	short	re;		//Current release value			(Q8)
	
	char	lv;		//Left volume
	char	rv;		//Right volume
	char	r3;		//Reserved
	char	r4;		//Reserved
	int		ll;		//Loop length (Sample length - loop point)
} Am10_Channel;

typedef struct {
	int		ident;	//Identification code
	int		r1;		//Reserved
	short	mfreq;	//Mixing frequency
	short	r2;		//Reserved
	
	char	rvlvl;	//Reverb level
	char	r3;		//Reserved
	char	chncn;	//Maximum channels
	char	mavol;	//Master volume
} Am10_Mixer;

extern Am10_Mixer	Am10_MixingData;
extern Am10_Channel	Am10_ChannelData[32];
